pro plot_transit_rdf_crosssections_post_process_v23_anal

; Now called from master program postproc_and_plot_all_texaqs_traj.pro,
;  so compile subprograms there (ie, comment out next line)
;@read_rdf_post_process_arcpac

; program: read_rdf_post_processed.pro 
; version for GFS_v23 simulations

; main program starts here

dirw='/data/bpierce/RAPID_RESPONSE/UW-Hybrid_traject/Lagrangian_averaged/'

close,11
openr,11,'plotfiles_transit_anal.fil'
nfiles=0L
ifile=' '
readf,11,nfiles
print,nfiles

;ifiles=[$ 
;'rdf_regional_2006081818__0-day_fixsdf.dat',$
;'rdf_regional_2006081818__5-day_fixsdf.dat',$
;'rdf_regional_2006081918__0-day_fixsdf.dat',$
;'rdf_regional_2006081918__5-day_fixsdf.dat',$
;'rdf_regional_2006082018__0-day_fixsdf.dat',$
;'rdf_regional_2006082018__5-day_fixsdf.dat',$
;'rdf_regional_2006082118__0-day_fixsdf.dat',$
;'rdf_regional_2006082118__5-day_fixsdf.dat'$
;]

dlab=[$
'0-day',$
'5-day',$
'0-day',$
'5-day',$
'0-day',$
'5-day',$
'0-day',$
'5-day',$
'0-day',$
'5-day',$
'0-day',$
'5-day',$
'0-day',$
'5-day',$
'0-day',$
'5-day',$
'0-day',$
'5-day',$
'0-day',$
'5-day',$
'0-day',$
'5-day',$
'0-day',$
'5-day',$
'0-day',$
'5-day',$
'0-day',$
'5-day',$
'0-day',$
'5-day',$
'0-day',$
'5-day',$
'0-day',$
'5-day',$
'0-day',$
'5-day',$
'0-day',$
'5-day',$
'0-day',$
'5-day',$
'0-day',$
'5-day'$
]
tesplot='.false.'
; loop over files
;nfiles=n_elements(ifiles)

setplot='Z'
set_plot,setplot
if setplot eq 'Z' then begin
 device,set_resolution=[960,720],z_buffer=0
 erase
 nxpng=!d.x_size
 nypng=!d.y_size
 loadct,45,file='./color_ck.tbl'
 !p.background=254.
 !p.color=255.
 erase
endif

for ifl=0, nfiles-1 do begin    ; loop over processed files
;for ifl=0, 1 do begin    ; loop over processed files

;ifile=ifiles(ifl)
readf,11,ifile
ifile=strtrim(ifile,2)
print,ifile
ifile=ifile

date=strmid(ifile,13,10)
rdfd=strmid(ifile,25,5)
; additional to v23
;       read_rdf_post_process_arcpac,$
;         dirw,ifile,xnd,ynd,znd,$
;         xmap,ymap,pmap,tmpmap,pvavemap,agemap,$
;     qdfavemap,stratmap,pblconusmap,pbltropicsmap,pbleasiamap,pblmap,altmap,$
;     tracermap,$
;     ih2o, iox, inoy, ipan, inox, ioxprod, iphytndox, iwetdepox, $
;     iassm3dox, iassmcolox, inoyprod, iphytndnoy, iwetdepnoy, ilnox, icmflx, $
;     ico, ibro, iso4, idust, $
;     issalt, ibcoc, $
;     ipannoy, inoxnoy
; additional to v24
       read_rdf_post_process_arcpac_24,$
         dirw,ifile,xnd,ynd,znd,$
         xmap,ymap,pmap,tmpmap,pvavemap,agemap,$
     qdfavemap,savemap,stratmap,pblconusmap,pbltropicsmap,pbleasiamap,pblmap,altmap,$
     tracermap,$
     ih2o, iox, inoy, ipan, inox, ioxprod, iphytndox, iwetdepox, $
     inoyprod, iphytndnoy, iwetdepnoy, ilnox, icmflx, $
     ico, ibro, iso4, idust, $
     issalt, ibcoc, $
     ipannoy, inoxnoy
;pblconusmap=pblconusmap+pbltropicsmap+pbleasiamap
nx=n_elements(xnd)
ny=n_elements(ynd)
nz=n_elements(znd)
nt=23l
if rdfd eq '0-day' then begin
xgrd=reform(xmap(*,*,nz-1),nx,ny)
ygrd=reform(ymap(*,*,nz-1),nx,ny)
p0=pmap
z0=altmap
help,xgrd,ygrd,z0
close,99
odir='/data/bpierce/RAPID_RESPONSE/UW-Hybrid_traject/Lagrangian_averaged/'
openr,99,odir+'UWMET_'+date+'.dat',/f77
nr=0l
nc=0l
readu,99,nc,nr
alon=fltarr(nc)
alat=fltarr(nr)
readu,99,alon,alat
mslp=fltarr(nc,nr)
zsfc=fltarr(nc,nr)
usfc=fltarr(nc,nr)
vsfc=fltarr(nc,nr)
t500m=fltarr(nc,nr)
u500m=fltarr(nc,nr)
v500m=fltarr(nc,nr)
t1km=fltarr(nc,nr)
u1km=fltarr(nc,nr)
v1km=fltarr(nc,nr)
t2km=fltarr(nc,nr)
u2km=fltarr(nc,nr)
v2km=fltarr(nc,nr)
t3km=fltarr(nc,nr)
u3km=fltarr(nc,nr)
v3km=fltarr(nc,nr)
t4km=fltarr(nc,nr)
u4km=fltarr(nc,nr)
v4km=fltarr(nc,nr)
t5km=fltarr(nc,nr)
u5km=fltarr(nc,nr)
v5km=fltarr(nc,nr)
t6km=fltarr(nc,nr)
u6km=fltarr(nc,nr)
v6km=fltarr(nc,nr)
t7km=fltarr(nc,nr)
u7km=fltarr(nc,nr)
v7km=fltarr(nc,nr)
t8km=fltarr(nc,nr)
u8km=fltarr(nc,nr)
v8km=fltarr(nc,nr)
t9km=fltarr(nc,nr)
u9km=fltarr(nc,nr)
v9km=fltarr(nc,nr)
t10km=fltarr(nc,nr)
u10km=fltarr(nc,nr)
v10km=fltarr(nc,nr)

readu,99,mslp,usfc,vsfc
readu,99,t500m,u500m,v500m
readu,99,t1km,u1km,v1km
readu,99,t2km,u2km,v2km
readu,99,t3km,u3km,v3km
readu,99,t4km,u4km,v4km
readu,99,t5km,u5km,v5km
readu,99,t6km,u6km,v6km
readu,99,t7km,u7km,v7km
readu,99,t8km,u8km,v8km
readu,99,t9km,u9km,v9km
readu,99,t10km,u10km,v10km
close,99
openr,99,'zsfc.dat',/f77
readu,99,nc,nr
zsfc=fltarr(nc,nr)
readu,99,alon,alat
readu,99,zsfc
help,zsfc
;
; smooth mslp
;
for j=0,nr-1 do begin
mslp(*,j)=smooth(mslp(*,j),3)
endfor
for i=0,nr-1 do begin
mslp(i,*)=smooth(mslp(i,*),3)
endfor
;
; interpolate to highres grid
;
nl=11l
zdum=fltarr(nc,ny)
udum=fltarr(nc,ny,nl)
vdum=fltarr(nc,ny,nl)
for i=0,nc-1 do begin
for j=0,ny-1 do begin
zdum(i,j)=interpol(zsfc(i,*),alat,ygrd(0,j))
udum(i,j,0)=interpol(usfc(i,*),alat,ygrd(0,j))
udum(i,j,1)=interpol(u1km(i,*),alat,ygrd(0,j))
udum(i,j,2)=interpol(u2km(i,*),alat,ygrd(0,j))
udum(i,j,3)=interpol(u3km(i,*),alat,ygrd(0,j))
udum(i,j,4)=interpol(u4km(i,*),alat,ygrd(0,j))
udum(i,j,5)=interpol(u5km(i,*),alat,ygrd(0,j))
udum(i,j,6)=interpol(u6km(i,*),alat,ygrd(0,j))
udum(i,j,7)=interpol(u7km(i,*),alat,ygrd(0,j))
udum(i,j,8)=interpol(u8km(i,*),alat,ygrd(0,j))
udum(i,j,9)=interpol(u9km(i,*),alat,ygrd(0,j))
udum(i,j,10)=interpol(u10km(i,*),alat,ygrd(0,j))
;
vdum(i,j,0)=interpol(vsfc(i,*),alat,ygrd(0,j))
vdum(i,j,1)=interpol(v1km(i,*),alat,ygrd(0,j))
vdum(i,j,2)=interpol(v2km(i,*),alat,ygrd(0,j))
vdum(i,j,3)=interpol(v3km(i,*),alat,ygrd(0,j))
vdum(i,j,4)=interpol(v4km(i,*),alat,ygrd(0,j))
vdum(i,j,5)=interpol(v5km(i,*),alat,ygrd(0,j))
vdum(i,j,6)=interpol(v6km(i,*),alat,ygrd(0,j))
vdum(i,j,7)=interpol(v7km(i,*),alat,ygrd(0,j))
vdum(i,j,8)=interpol(v8km(i,*),alat,ygrd(0,j))
vdum(i,j,9)=interpol(v9km(i,*),alat,ygrd(0,j))
vdum(i,j,10)=interpol(v10km(i,*),alat,ygrd(0,j))

endfor
endfor
zgrd=fltarr(nx,ny)
ugrd=fltarr(nx,ny,nl)
vgrd=fltarr(nx,ny,nl)
for i=0,nx-1 do begin
for j=0,ny-1 do begin
zgrd(i,j)=interpol(zdum(*,j),alon,xgrd(i,0))
for l=0,nl-1 do begin
ugrd(i,j,l)=interpol(udum(*,j,l),alon,xgrd(i,0))
vgrd(i,j,l)=interpol(vdum(*,j,l),alon,xgrd(i,0))
endfor
;z0(i,j,*)=z0(i,j,*)-zgrd(i,j)
endfor
endfor
goto, jumpout
endif
;if rdfd eq '5-day' then begin
;set_plot,'x'
;!psym=3
;plot_oo,10^tracermap(ivocage,*,*,*),1e12*tracermap(ipropar,*,*,*)/3,xtitle='alog10(ethane/propane),$
;ytitle='Propane (pptv)'
;stop
;endif

;
xsec=[-165.000,-160.000,-155.000,-150.000,-145.000,-140.000,-135.000,-130.000,-125.000,-120.000,-110.000,-105.000]
xlab=['165W','160W','155W','150W','145W','140W','135W','130W','125W','120W','110W','105W']
nsec=n_elements(xsec)
;
; plot rdf pan/noy
;
xdum=xgrd(*,0)-360.
yplt=fltarr(ny,nz)
yplt1d=reform(ygrd(0,*),ny)
zplt1d=findgen(nl)
for l=0,nz-1 do begin
yplt(*,l)=reform(ygrd(0,*),ny)
endfor
;
for i=0,nsec-1 do begin
pindex=where(xdum eq xsec(i))
print,xdum(pindex(0))
zplt=fltarr(ny,nz)
splt=sqrt((reform(ugrd(pindex(0),*,*),ny,nl))^2+(reform(vgrd(pindex(0),*,*),ny,nl))^2)
for l=0,nz-1 do begin
zplt(*,l)=z0(pindex(0),*,l)/1000.
endfor
title=xlab(i)+' '+dlab(ifl)+' Lagrangian Averaged PAN/NOy '+date+' !C (Windspeed contoured)'
erase
set_viewport,.1,.9,.2,.9
mcolor=253.
ymin=min(ygrd)
ymax=max(ygrd)
!type=2^2+2^3
plot,[ymin,ymax],[0,10],/nodata,xtitle='Latitude',ytitle='Altitude (km)',title=title
daymap=reform(tracermap(ipannoy,pindex(0),*,*),ny,nz)
level=1.*findgen(31)/30.
color=mcolor*findgen(31)/30.
contour,daymap,yplt,zplt,/overplot,level=level,/cell_fill,c_colors=color
slev=5*findgen(31)
contour,splt,yplt1d,zplt1d,/overplot,level=slev,/follow
xmn=.1   ; lower-left
xmx=.9   ; lower-right
ymn=.15  ; the third element of set_viewport
ymx=.9  ; the fourth element of set_viewport
cbaryoff=.05; y distance between plot origin and colorbar origin
cbarydel=.01 ; thickness of colorbar
icmm1=253. ; icolmax-1, where icolmax is (number of colors) - 1
xtitle='(ppbv/ppbv)'
color_bar_png,level,xmn,ymn,xmx,ymx,cbaryoff,cbarydel,icmm1,xtitle


if setplot eq 'Z' then begin
 image=tvrd(0,0,nxpng,nypng)
 image_byt=bytscl(image,min=0,max=255)
 index=where(image_byt gt 0B and image_byt lt 255B)
 tvlct,r,g,b,/get
pngdir='PNG_images/'
 write_png,pngdir+ifile+'.ipannoy.'+xlab(i)+'.transit.anal.rmin.1.0.degree.png',image_byt,r,g,b
endif
;
; plot rdf ozone
;
title=xlab(i)+' '+dlab(ifl)+' Lagrangian Averaged Ozone '+date+' !C (Windspeed contoured)'
erase
set_viewport,.1,.9,.2,.9
mcolor=253.
ymin=min(ygrd)
ymax=max(ygrd)
!type=2^2+2^3
plot,[ymin,ymax],[0,10],/nodata,xtitle='Latitude',ytitle='Altitude (km)',title=title
daymap=1e9*reform(tracermap(iox,pindex(0),*,*),ny,nz)
level=120.*findgen(31)/30.
color=mcolor*findgen(31)/30.
contour,daymap,yplt,zplt,/overplot,level=level,/cell_fill,c_colors=color
slev=5*findgen(31)
contour,splt,yplt1d,zplt1d,/overplot,level=slev,/follow
xmn=.1   ; lower-left
xmx=.9   ; lower-right
ymn=.15  ; the third element of set_viewport
ymx=.9  ; the fourth element of set_viewport
cbaryoff=.05; y distance between plot origin and colorbar origin
cbarydel=.01 ; thickness of colorbar
icmm1=253. ; icolmax-1, where icolmax is (number of colors) - 1
xtitle='(ppbv)'
color_bar_png,level,xmn,ymn,xmx,ymx,cbaryoff,cbarydel,icmm1,xtitle


if setplot eq 'Z' then begin
 image=tvrd(0,0,nxpng,nypng)
 image_byt=bytscl(image,min=0,max=255)
 index=where(image_byt gt 0B and image_byt lt 255B)
 tvlct,r,g,b,/get
pngdir='PNG_images/'
 write_png,pngdir+ifile+'.iox.'+xlab(i)+'.transit.anal.rmin.1.0.degree.png',image_byt,r,g,b
endif
;
; plot rdf windspeed
;
title=xlab(i)+' '+dlab(ifl)+' Lagrangian Averaged WindSpeed '+date+' !C (Windspeed contoured)'
erase
set_viewport,.1,.9,.2,.9
mcolor=253.
ymin=min(ygrd)
ymax=max(ygrd)
!type=2^2+2^3
plot,[ymin,ymax],[0,10],/nodata,xtitle='Latitude',ytitle='Altitude (km)',title=title
daymap=reform(savemap(pindex(0),*,*),ny,nz)
level=40.*findgen(31)/30.
color=mcolor*findgen(31)/30.
contour,daymap,yplt,zplt,/overplot,level=level,/cell_fill,c_colors=color
slev=5*findgen(31)
contour,splt,yplt1d,zplt1d,/overplot,level=slev,/follow
xmn=.1   ; lower-left
xmx=.9   ; lower-right
ymn=.15  ; the third element of set_viewport
ymx=.9  ; the fourth element of set_viewport
cbaryoff=.05; y distance between plot origin and colorbar origin
cbarydel=.01 ; thickness of colorbar
icmm1=253. ; icolmax-1, where icolmax is (number of colors) - 1
xtitle='(ppbv/ppbv)'
color_bar_png,level,xmn,ymn,xmx,ymx,cbaryoff,cbarydel,icmm1,xtitle
if setplot eq 'Z' then begin
 image=tvrd(0,0,nxpng,nypng)
 image_byt=bytscl(image,min=0,max=255)
 index=where(image_byt gt 0B and image_byt lt 255B)
 tvlct,r,g,b,/get
pngdir='PNG_images/'
 write_png,pngdir+ifile+'.speed.'+xlab(i)+'.transit.anal.rmin.1.0.degree.png',image_byt,r,g,b
endif


;
; plot rdf Mixing
;
title=xlab(i)+' '+dlab(ifl)+'  Lagrangian Mixing  '+date+' !C (Windspeed contoured)'
erase
set_viewport,.1,.9,.2,.9
mcolor=253.
ymin=min(ygrd)
ymax=max(ygrd)
!type=2^2+2^3
plot,[ymin,ymax],[0,10],/nodata,xtitle='Latitude',ytitle='Altitude (km)',title=title
daymap=reform(qdfavemap(pindex(0),*,*),ny,nz)
level=-200.+400.*findgen(31)/30.
color=mcolor*findgen(31)/30.
contour,daymap,yplt,zplt,/overplot,level=level,/cell_fill,c_colors=color,max_val=9999.
slev=5*findgen(31)
contour,splt,yplt1d,zplt1d,/overplot,level=slev,/follow
xmn=.1   ; lower-left
xmx=.9   ; lower-right
ymn=.15  ; the third element of set_viewport
ymx=.9  ; the fourth element of set_viewport
cbaryoff=.05; y distance between plot origin and colorbar origin
cbarydel=.01 ; thickness of colorbar
icmm1=253. ; icolmax-1, where icolmax is (number of colors) - 1
xtitle='(sec!u-1!n)'
color_bar_png,level,xmn,ymn,xmx,ymx,cbaryoff,cbarydel,icmm1,xtitle

if setplot eq 'Z' then begin
 image=tvrd(0,0,nxpng,nypng)
 image_byt=bytscl(image,min=0,max=255)
 index=where(image_byt gt 0B and image_byt lt 255B)
 tvlct,r,g,b,/get
pngdir='PNG_images/'
 write_png,pngdir+ifile+'.qdf.'+xlab(i)+'.transit.anal.rmin.1.0.degree.png',image_byt,r,g,b
endif
endfor
jumpout:
endfor    ; end of loop over trajectory runs 

close,11
end

