pro plot_region_rdf_post_process_v24_anal

; Now called from master program postproc_and_plot_all_texaqs_traj.pro,
;  so compile subprograms there (ie, comment out next line)
;@read_rdf_post_process_arcpac

; program: read_rdf_post_processed.pro 
; version for GFS_v23 simulations

; main program starts here

dirw='/odyssey/proxy/bpierce/KORUS-AQ/UW-Hybrid_traject/Lagrangian_averaged/'

close,11
openr,11,'plotfiles_korus-aq_anal.fil'
nfiles=0L
ifile=' '
readf,11,nfiles
print,nfiles

;ifiles=[$ 
;'rdf_regional_2006081818__0-day_fixsdf.dat',$
;'rdf_regional_2006081818__5-day_fixsdf.dat',$
;'rdf_regional_2006081918__0-day_fixsdf.dat',$
;'rdf_regional_2006081918__5-day_fixsdf.dat',$
;'rdf_regional_2006082018__0-day_fixsdf.dat',$
;'rdf_regional_2006082018__5-day_fixsdf.dat',$
;'rdf_regional_2006082118__0-day_fixsdf.dat',$
;'rdf_regional_2006082118__5-day_fixsdf.dat'$
;]

dlab=[$
'0-day',$
'5-day',$
'0-day',$
'5-day',$
'0-day',$
'5-day',$
'0-day',$
'5-day',$
'0-day',$
'5-day',$
'0-day',$
'5-day',$
'0-day',$
'5-day',$
'0-day',$
'5-day',$
'0-day',$
'5-day',$
'0-day',$
'5-day',$
'0-day',$
'5-day',$
'0-day',$
'5-day',$
'0-day',$
'5-day',$
'0-day',$
'5-day',$
'0-day',$
'5-day',$
'0-day',$
'5-day',$
'0-day',$
'5-day',$
'0-day',$
'5-day',$
'0-day',$
'5-day',$
'0-day',$
'5-day',$
'0-day',$
'5-day'$
]
tesplot='.false.'
; loop over files
;nfiles=n_elements(ifiles)

setplot='Z'
set_plot,setplot
if setplot eq 'Z' then begin
 device,set_resolution=[960,720],z_buffer=0
 erase
 nxpng=!d.x_size
 nypng=!d.y_size
 loadct,45,file='./color_ck.tbl'
 !p.background=254.
 !p.color=255.
 erase
endif

for ifl=0, nfiles-1 do begin    ; loop over processed files
;for ifl=0, 1 do begin    ; loop over processed files

;ifile=ifiles(ifl)
readf,11,ifile
ifile=strtrim(ifile,2)
print,ifile

date=strmid(ifile,13,10)
rdfd=strmid(ifile,25,5)
; additional to v23
;       read_rdf_post_process_arcpac,$
;         dirw,ifile,xnd,ynd,znd,$
;         xmap,ymap,pmap,tmpmap,pvavemap,agemap,$
;     qdfavemap,stratmap,pblconusmap,pbltropicsmap,pbleasiamap,pblmap,altmap,$
;     tracermap,$
;     ih2o, iox, inoy, ipan, inox, ioxprod, iphytndox, iwetdepox, $
;     iassm3dox, iassmcolox, inoyprod, iphytndnoy, iwetdepnoy, ilnox, icmflx, $
;     ico, ibro, iso4, idust, $
;     issalt, ibcoc, $
;     ipannoy, inoxnoy
; additional to v24
       read_rdf_post_process_arcpac_24,$
         dirw,ifile,xnd,ynd,znd,$
         xmap,ymap,pmap,tmpmap,pvavemap,agemap,$
     qdfavemap,savemap,stratmap,pblconusmap,pbltropicsmap,pbleasiamap,pblmap,altmap,$
     tracermap,$
     ih2o, iox, inoy, ipan, inox, ioxprod, iphytndox, iwetdepox, $
     ilnox, icmflx, $
     ico, ibro, iso4, idust, $
     issalt, ibcoc, $
     ipannoy, inoxnoy, ico25d

;pblconusmap=pblconusmap+pbltropicsmap+pbleasiamap
nx=n_elements(xnd)
ny=n_elements(ynd)
nz=n_elements(znd)
nt=21
if rdfd eq '0-day' then begin
xgrd=reform(xmap(*,*,nz-1),nx,ny)
ygrd=reform(ymap(*,*,nz-1),nx,ny)
p0=pmap
z0=altmap
close,99
odir='/odyssey/proxy/bpierce/KORUS-AQ/UW-Hybrid_traject/Lagrangian_averaged/'
openr,99,odir+'UWMET_'+date+'.dat',/f77
nr=0l
nc=0l
readu,99,nc,nr
alon=fltarr(nc)
alat=fltarr(nr)
readu,99,alon,alat
mslp=fltarr(nc,nr)
zsfc=fltarr(nc,nr)
usfc=fltarr(nc,nr)
vsfc=fltarr(nc,nr)
t500m=fltarr(nc,nr)
u500m=fltarr(nc,nr)
v500m=fltarr(nc,nr)
t1km=fltarr(nc,nr)
u1km=fltarr(nc,nr)
v1km=fltarr(nc,nr)
t2km=fltarr(nc,nr)
u2km=fltarr(nc,nr)
v2km=fltarr(nc,nr)
t3km=fltarr(nc,nr)
u3km=fltarr(nc,nr)
v3km=fltarr(nc,nr)
t4km=fltarr(nc,nr)
u4km=fltarr(nc,nr)
v4km=fltarr(nc,nr)
t5km=fltarr(nc,nr)
u5km=fltarr(nc,nr)
v5km=fltarr(nc,nr)
t6km=fltarr(nc,nr)
u6km=fltarr(nc,nr)
v6km=fltarr(nc,nr)
t7km=fltarr(nc,nr)
u7km=fltarr(nc,nr)
v7km=fltarr(nc,nr)
t8km=fltarr(nc,nr)
u8km=fltarr(nc,nr)
v8km=fltarr(nc,nr)
t9km=fltarr(nc,nr)
u9km=fltarr(nc,nr)
v9km=fltarr(nc,nr)
t10km=fltarr(nc,nr)
u10km=fltarr(nc,nr)
v10km=fltarr(nc,nr)

readu,99,mslp,usfc,vsfc
readu,99,t500m,u500m,v500m
readu,99,t1km,u1km,v1km
readu,99,t2km,u2km,v2km
readu,99,t3km,u3km,v3km
readu,99,t4km,u4km,v4km
readu,99,t5km,u5km,v5km
readu,99,t6km,u6km,v6km
readu,99,t7km,u7km,v7km
readu,99,t8km,u8km,v8km
readu,99,t9km,u9km,v9km
readu,99,t10km,u10km,v10km
close,99
openr,99,'zsfc.dat',/f77
readu,99,nc,nr
zsfc=fltarr(nc,nr)
readu,99,alon,alat
readu,99,zsfc
help,zsfc
;
; smooth mslp
;
for j=0,nr-1 do begin
mslp(*,j)=smooth(mslp(*,j),3)
endfor
for i=0,nr-1 do begin
mslp(i,*)=smooth(mslp(i,*),3)
endfor
;
; interpolate zsfc to highres grid
;
zdum=fltarr(nc,ny)
for i=0,nc-1 do begin
for j=0,ny-1 do begin
zdum(i,j)=interpol(zsfc(i,*),alat,ygrd(0,j))
endfor
endfor
zgrd=fltarr(nx,ny)
for i=0,nx-1 do begin
for j=0,ny-1 do begin
zgrd(i,j)=interpol(zdum(*,j),alon,xgrd(i,0))
;z0(i,j,*)=z0(i,j,*)-zgrd(i,j)
endfor
endfor
goto, jumpout
endif
;if rdfd eq '5-day' then begin
;set_plot,'x'
;!psym=3
;plot_oo,10^tracermap(ivocage,*,*,*),1e12*tracermap(ipropar,*,*,*)/3,xtitle='alog10(ethane/propane),$
;ytitle='Propane (pptv)'
;stop
;endif

;
; interpolate to 3km and 5km agl
;
zlev=[10000.,9000.,8000.,7000.,6000.,5000.,4000.,3000.,2000.,1000.,0.]
zlab=['10km','9km','8km','7km','6km','5km','4km','3km','2km','1km','SFC']
;lev=['lev_6','lev_5','lev_4','lev_3','lev_2','lev_1']
nlev=n_elements(zlev)
dp=p0-pmap
ptracer=-9999+fltarr(nt+5,nx,ny,nlev)
;
help,nt
help,tracermap
for i=0,nx-1 do begin
for j=0,ny-1 do begin
;
; surface
;
ptracer(0:nt-1,i,j,nlev-1)=tracermap(0:nt-1,i,j,nz-1)
ptracer(nt,i,j,nlev-1)=stratmap(i,j,nz-1)
ptracer(nt+1,i,j,nlev-1)=pbltropicsmap(i,j,nz-1)
ptracer(nt+2,i,j,nlev-1)=pbleasiamap(i,j,nz-1)
ptracer(nt+3,i,j,nlev-1)=qdfavemap(i,j,nz-1)
ptracer(nt+4,i,j,nlev-1)=savemap(i,j,nz-1)




;
; tracers
;
for n=0,nt-1 do begin
for l=0,nlev-2 do begin
dummy=reform(z0(i,j,*),nz)
if max(dummy) ge zlev(l) and min(dummy) le zlev(l) then $
ptracer(n,i,j,l)=interpol(tracermap(n,i,j,*),z0(i,j,*),zlev(l))
endfor
endfor
;
; delta p pblflag geopotential
;
for l=0,nlev-2 do begin
dummy=reform(z0(i,j,*),nz)
if max(dummy) ge zlev(l) and min(dummy) le zlev(l) then begin
ptracer(nt,i,j,l)=interpol(stratmap(i,j,*),z0(i,j,*),zlev(l))
ptracer(nt+1,i,j,l)=interpol(pbltropicsmap(i,j,*),z0(i,j,*),zlev(l))
ptracer(nt+2,i,j,l)=interpol(pbleasiamap(i,j,*),z0(i,j,*),zlev(l))
ptracer(nt+3,i,j,l)=interpol(qdfavemap(i,j,*),z0(i,j,*),zlev(l))
ptracer(nt+4,i,j,l)=interpol(savemap(i,j,*),z0(i,j,*),zlev(l))


endif
endfor
endfor
endfor
;
; plot rdf pan/noy
;
for l=0,nlev-1 do begin
title=zlab(l)+' '+dlab(ifl)+' Lagrangian Averaged PAN/NOy '+date
erase
set_viewport,.2,.8,.15,.9
mcolor=253.
map_set,0,-180,0,/continents,/us,limit=[30,120,45,135],$ 
title=title
daymap=reform(ptracer(ipannoy,*,*,l),nx,ny)
level=.6*findgen(31)/30.
color=mcolor*findgen(31)/30.
contour,daymap,xgrd,ygrd,/overplot,level=level,/cell_fill,c_colors=color
if l eq 0 then begin
udata=u10km
vdata=v10km
;tlevel=240+5*findgen(31)
;contour,t5km,alon,alat,/overplot,level=tlevel,/follow
plevel=940+4.*findgen(31)
;contour,mslp,alon,alat,/overplot,level=plevel,/follow
endif
if l eq 1 then begin
udata=u9km
vdata=v9km
;tlevel=240+5*findgen(31)
;contour,t3km,alon,alat,/overplot,level=tlevel,/follow
plevel=940+4.*findgen(31)
;contour,mslp,alon,alat,/overplot,level=plevel,/follow
endif

if l eq 2 then begin
udata=u8km
vdata=v8km
plevel=940+4.*findgen(31)
;contour,mslp,alon,alat,/overplot,level=plevel,/follow
endif
if l eq 3 then begin
udata=u7km
vdata=v7km
plevel=940+4.*findgen(31)
;contour,mslp,alon,alat,/overplot,level=plevel,/follow
endif
if l eq 4 then begin
udata=u6km
vdata=v6km
plevel=940+4.*findgen(31)
;contour,mslp,alon,alat,/overplot,level=plevel,/follow
endif
if l eq 5 then begin
udata=u5km
vdata=v5km
plevel=940+4.*findgen(31)
;contour,mslp,alon,alat,/overplot,level=plevel,/follow
endif
if l eq 6 then begin
udata=u4km
vdata=v4km
plevel=940+4.*findgen(31)
;contour,mslp,alon,alat,/overplot,level=plevel,/follow
endif
if l eq 7 then begin
udata=u3km
vdata=v3km
plevel=940+4.*findgen(31)
;contour,mslp,alon,alat,/overplot,level=plevel,/follow
endif
if l eq 8 then begin
udata=u2km
vdata=v2km
plevel=940+4.*findgen(31)
;contour,mslp,alon,alat,/overplot,level=plevel,/follow
endif
if l eq 9 then begin
udata=u1km
vdata=v1km
plevel=940+4.*findgen(31)
;contour,mslp,alon,alat,/overplot,level=plevel,/follow
endif
if l eq 10 then begin
udata=usfc
vdata=vsfc
plevel=940+4.*findgen(31)
;contour,mslp,alon,alat,/overplot,level=plevel,/follow
endif

map_set,0,-180,0,/continents,/us,limit=[30,120,45,135],$ 
/noeras
map_grid_ck,londel=5,latdel=1,/label
!p.thick=1
colors=mcolor+[0B,0B,0B,0B,0B,0B,0B]
;;       DrawCounties, 'co2000p020.shp', Statenames=['CA', 'OR', 'WA', 'AZ', 'UT', 'ID', 'NV'], $
          Colors=colors
;
; draw vectors
;
maxmag=17.5
nh=1
!psym=0
vcolor=mcolor-.3*mcolor
vcolor=mcolor
xmax=250
xmin=225
ymax=45
ymin=25
xmax=260
xmin=235
ymax=50
ymin=30
xmax=255
xmin=195
ymax=60
ymin=15
xmax=135
xmin=120
ymax=45
ymin=30
!linetype=0
drawvectors_all,xmax,xmin,ymax,ymin,nc,nr,alon,alat,udata,vdata,maxmag,nh,vcolor
;Latitude: 40 03 00.10028(N)
;Longitude: 105 00 13.80781(W)
;lab_station=['Fort Collins']
;lat_station=[40.579]
;lon_station=[-105.078]
!psym=4
oplot,[-105.,-105.],[40.5,40.5]
!psym=0
;ktlx_range_ring
print,max(daymap),min(daymap)
if tesplot ne '.false.' then begin
tesdir='/data/ARCPAC/TES/Binary/'
tesfiles='tes_files_airnow_'+date+'.dat
close,2
openr,2,tesfiles
ntes=0l
readf,2,ntes
if ntes ne 0 then begin
tesfile=''
for ntimes=0,ntes-1 do begin
readf,2,tesfile
teslab=strmid(tesfile,35,9)
close,88
openr,88,tesdir+tesfile,/f77
nttes=0l
nltes=0l
readu,88,nltes,nttes
print,nltes,nttes
co_retrieval=fltarr(nltes,nttes)
co_initial=fltarr(nltes,nttes)
co_precision=fltarr(nltes,nttes)
o3_retrieval=fltarr(nltes,nttes)
o3_initial=fltarr(nltes,nttes)
o3_precision=fltarr(nltes,nttes)
cld_opt_depth=fltarr(nltes,nttes)
pres_retrieval=fltarr(nltes,nttes)
alt_retrieval=fltarr(nltes,nttes)
time_retrieval=fltarr(nltes,nttes)
lat_retrieval=fltarr(nltes,nttes)
lon_retrieval=fltarr(nltes,nttes)
readu,88,cld_opt_depth,pres_retrieval,alt_retrieval,time_retrieval,lat_retrieval,lon_retrieval
readu,88,co_retrieval,co_initial,co_precision
readu,88,o3_retrieval,o3_initial,o3_precision
close,88
lons=lon_retrieval(0,*)
lats=lat_retrieval(0,*)
print,max(lats),min(lats)
!psym=-2
oplot,lons,lats
!psym=0
xyouts,lons(nttes/2),lats(nttes/2),'TES '+teslab
endfor
endif
endif
xmn=.2   ; lower-left
xmx=.8   ; lower-right
ymn=.15  ; the third element of set_viewport
ymx=.9  ; the fourth element of set_viewport
cbaryoff=.05; y distance between plot origin and colorbar origin
cbarydel=.01 ; thickness of colorbar
icmm1=253. ; icolmax-1, where icolmax is (number of colors) - 1
xtitle='(ppbv/ppbv)'
color_bar_png,level,xmn,ymn,xmx,ymx,cbaryoff,cbarydel,icmm1,xtitle


if setplot eq 'Z' then begin
 image=tvrd(0,0,nxpng,nypng)
 image_byt=bytscl(image,min=0,max=255)
 index=where(image_byt gt 0B and image_byt lt 255B)
 tvlct,r,g,b,/get
pngdir='PNG_images/'
 write_png,pngdir+ifile+'.ipannoy.'+zlab(l)+'.anal.small.domain.png',image_byt,r,g,b
endif
;
; plot rdf Smoke CO
;
title=zlab(l)+' '+dlab(ifl)+' Lagrangian Averaged Biomass Burning CO '+date
erase
set_viewport,.2,.8,.15,.9
mcolor=253.
map_set,0,-180,0,/continents,/us,limit=[30,120,45,135],$ 
title=title
daymap=1.e9*reform(ptracer(ico25d,*,*,l),nx,ny)
level=300.*findgen(31)/30.
color=mcolor*findgen(31)/30.
contour,daymap,xgrd,ygrd,/overplot,level=level,/cell_fill,c_colors=color
map_set,0,-180,0,/continents,/us,limit=[30,120,45,135],$ 
/noeras
map_grid_ck,londel=5,latdel=1,/label
!p.thick=1
colors=mcolor+[0B,0B,0B,0B,0B,0B,0B]
;       DrawCounties, 'co2000p020.shp', Statenames=['CA', 'OR', 'WA', 'AZ', 'UT', 'ID', 'NV'], $
          Colors=colors
;
; draw vectors
;
maxmag=17.5
nh=1
!psym=0
vcolor=mcolor-.3*mcolor
vcolor=mcolor
xmax=250
xmin=225
ymax=45
ymin=25
xmax=260
xmin=235
ymax=50
ymin=30
xmax=255
xmin=195
ymax=60
ymin=15
xmax=135
xmin=120
ymax=45
ymin=30

!linetype=0
drawvectors_all,xmax,xmin,ymax,ymin,nc,nr,alon,alat,udata,vdata,maxmag,nh,vcolor
;Latitude: 40 03 00.10028(N)
;Longitude: 105 00 13.80781(W)
!psym=4
oplot,[-105.,-105.],[40.5,40.5]
!psym=0

;ktlx_range_ring
print,max(daymap),min(daymap)
if tesplot ne '.false.' then begin
close,2
openr,2,tesfiles
ntes=0l
readf,2,ntes
if ntes ne 0 then begin
tesfile=''
for ntimes=0,ntes-1 do begin
readf,2,tesfile
teslab=strmid(tesfile,35,9)
close,88
openr,88,tesdir+tesfile,/f77
nttes=0l
nltes=0l
readu,88,nltes,nttes
print,nltes,nttes
co_retrieval=fltarr(nltes,nttes)
co_initial=fltarr(nltes,nttes)
co_precision=fltarr(nltes,nttes)
o3_retrieval=fltarr(nltes,nttes)
o3_initial=fltarr(nltes,nttes)
o3_precision=fltarr(nltes,nttes)
cld_opt_depth=fltarr(nltes,nttes)
pres_retrieval=fltarr(nltes,nttes)
alt_retrieval=fltarr(nltes,nttes)
time_retrieval=fltarr(nltes,nttes)
lat_retrieval=fltarr(nltes,nttes)
lon_retrieval=fltarr(nltes,nttes)
readu,88,cld_opt_depth,pres_retrieval,alt_retrieval,time_retrieval,lat_retrieval,lon_retrieval
readu,88,co_retrieval,co_initial,co_precision
readu,88,o3_retrieval,o3_initial,o3_precision
close,88
lons=lon_retrieval(0,*)
lats=lat_retrieval(0,*)
print,max(lats),min(lats)
!psym=-2
oplot,lons,lats
!psym=0
xyouts,lons(nttes/2),lats(nttes/2),'TES '+teslab
endfor
endif
endif

xmn=.1   ; lower-left
xmx=.9   ; lower-right
ymn=.15  ; the third element of set_viewport
ymx=.9  ; the fourth element of set_viewport
cbaryoff=.05; y distance between plot origin and colorbar origin
cbarydel=.01 ; thickness of colorbar
icmm1=253. ; icolmax-1, where icolmax is (number of colors) - 1
xtitle='(ppbv/day)'
color_bar_png,level,xmn,ymn,xmx,ymx,cbaryoff,cbarydel,icmm1,xtitle


if setplot eq 'Z' then begin
 image=tvrd(0,0,nxpng,nypng)
 image_byt=bytscl(image,min=0,max=255)
 index=where(image_byt gt 0B and image_byt lt 255B)
 tvlct,r,g,b,/get
pngdir='PNG_images/'
 write_png,pngdir+ifile+'.ico25d.'+zlab(l)+'.anal.small.domain.png',image_byt,r,g,b
endif
;
; plot rdf H2O
;
title=zlab(l)+' '+dlab(ifl)+' Lagrangian Averaged H2O '+date
erase
set_viewport,.2,.8,.15,.9
mcolor=253.
map_set,0,-180,0,/continents,/us,limit=[30,120,45,135],$ 
title=title
daymap=1.e3*reform(ptracer(ih2o,*,*,l),nx,ny)
level=20.*findgen(31)/30.
if l eq nlev-1 then level=20.*findgen(31)/30.
color=mcolor*findgen(31)/30.
contour,daymap,xgrd,ygrd,/overplot,level=level,/cell_fill,c_colors=color

map_set,0,-180,0,/continents,/us,limit=[30,120,45,135],$ 
/noeras
map_grid_ck,londel=5,latdel=1,/label
!p.thick=1
colors=mcolor+[0B,0B,0B,0B,0B,0B,0B]
;       DrawCounties, 'co2000p020.shp', Statenames=['CA', 'OR', 'WA', 'AZ', 'UT', 'ID', 'NV'], $
          Colors=colors
;
; draw vectors
;
maxmag=17.5
nh=1
!psym=0
vcolor=mcolor-.3*mcolor
vcolor=mcolor
xmax=250
xmin=90
ymax=90
ymin=50
xmax=250
xmin=225
ymax=45
ymin=25
xmax=260
xmin=235
ymax=50
ymin=30
xmax=255
xmin=195
ymax=60
ymin=15
xmax=135
xmin=120
ymax=45
ymin=30

!linetype=0
drawvectors_all,xmax,xmin,ymax,ymin,nc,nr,alon,alat,udata,vdata,maxmag,nh,vcolor
;Latitude: 40 03 00.10028(N)
;Longitude: 105 00 13.80781(W)
!psym=4
oplot,[-105.,-105.],[40.5,40.5]
!psym=0
;ktlx_range_ring
print,max(daymap),min(daymap)
if tesplot ne '.false.' then begin
close,2
openr,2,tesfiles
ntes=0l
readf,2,ntes
if ntes ne 0 then begin
tesfile=''
for ntimes=0,ntes-1 do begin
readf,2,tesfile
teslab=strmid(tesfile,35,9)
close,88
openr,88,tesdir+tesfile,/f77
nttes=0l
nltes=0l
readu,88,nltes,nttes
print,nltes,nttes
co_retrieval=fltarr(nltes,nttes)
co_initial=fltarr(nltes,nttes)
co_precision=fltarr(nltes,nttes)
o3_retrieval=fltarr(nltes,nttes)
o3_initial=fltarr(nltes,nttes)
o3_precision=fltarr(nltes,nttes)
cld_opt_depth=fltarr(nltes,nttes)
pres_retrieval=fltarr(nltes,nttes)
alt_retrieval=fltarr(nltes,nttes)
time_retrieval=fltarr(nltes,nttes)
lat_retrieval=fltarr(nltes,nttes)
lon_retrieval=fltarr(nltes,nttes)
readu,88,cld_opt_depth,pres_retrieval,alt_retrieval,time_retrieval,lat_retrieval,lon_retrieval
readu,88,co_retrieval,co_initial,co_precision
readu,88,o3_retrieval,o3_initial,o3_precision
close,88
lons=lon_retrieval(0,*)
lats=lat_retrieval(0,*)
print,max(lats),min(lats)
!psym=-2
oplot,lons,lats
!psym=0
xyouts,lons(nttes/2),lats(nttes/2),'TES '+teslab

endfor
endif
endif
xmn=.1   ; lower-left
xmx=.9   ; lower-right
ymn=.15  ; the third element of set_viewport
ymx=.9  ; the fourth element of set_viewport
cbaryoff=.05; y distance between plot origin and colorbar origin
cbarydel=.01 ; thickness of colorbar
icmm1=253. ; icolmax-1, where icolmax is (number of colors) - 1
xtitle='(g/kg)'
color_bar_png,level,xmn,ymn,xmx,ymx,cbaryoff,cbarydel,icmm1,xtitle


if setplot eq 'Z' then begin
 image=tvrd(0,0,nxpng,nypng)
 image_byt=bytscl(image,min=0,max=255)
 index=where(image_byt gt 0B and image_byt lt 255B)
 tvlct,r,g,b,/get
pngdir='PNG_images/'
 write_png,pngdir+ifile+'.ih2o.'+zlab(l)+'.anal.small.domain.png',image_byt,r,g,b
endif
;
; plot rdf QDF
;
title=zlab(l)+' '+dlab(ifl)+' Lagrangian Mixing '+date
erase
set_viewport,.2,.8,.15,.9
mcolor=253.
map_set,0,-180,0,/continents,/us,limit=[30,120,45,135],$ 
title=title
daymap=reform(ptracer(nt+3,*,*,l),nx,ny)
level=-100.+200.*findgen(31)/30.
color=mcolor*findgen(31)/30.
contour,daymap,xgrd,ygrd,/overplot,level=level,/cell_fill,c_colors=color
map_set,0,-180,0,/continents,/us,limit=[30,120,45,135],$ 
/noeras
map_grid_ck,londel=5,latdel=1,/label
!p.thick=1
colors=mcolor+[0B,0B,0B,0B,0B,0B,0B]
;       DrawCounties, 'co2000p020.shp', Statenames=['CA', 'OR', 'WA', 'AZ', 'UT', 'ID', 'NV'], $
          Colors=colors
;
; draw vectors
;
maxmag=17.5
nh=1
!psym=0
vcolor=mcolor-.3*mcolor
vcolor=mcolor
xmax=250
xmin=90
ymax=90
ymin=50
xmax=250
xmin=225
ymax=45
ymin=25
xmax=260
xmin=235
ymax=50
ymin=30
xmax=255
xmin=195
ymax=60
ymin=15
xmax=135
xmin=120
ymax=45
ymin=30

!linetype=0
drawvectors_all,xmax,xmin,ymax,ymin,nc,nr,alon,alat,udata,vdata,maxmag,nh,vcolor
;Latitude: 40 03 00.10028(N)
;Longitude: 105 00 13.80781(W)
!psym=4
oplot,[-105.,-105.],[40.5,40.5]
!psym=0
;ktlx_range_ring
print,max(daymap),min(daymap)
if tesplot ne '.false.' then begin
close,2
openr,2,tesfiles
ntes=0l
readf,2,ntes
if ntes ne 0 then begin
tesfile=''
for ntimes=0,ntes-1 do begin
readf,2,tesfile
teslab=strmid(tesfile,35,9)
close,88
openr,88,tesdir+tesfile,/f77
nttes=0l
nltes=0l
readu,88,nltes,nttes
print,nltes,nttes
co_retrieval=fltarr(nltes,nttes)
co_initial=fltarr(nltes,nttes)
co_precision=fltarr(nltes,nttes)
o3_retrieval=fltarr(nltes,nttes)
o3_initial=fltarr(nltes,nttes)
o3_precision=fltarr(nltes,nttes)
cld_opt_depth=fltarr(nltes,nttes)
pres_retrieval=fltarr(nltes,nttes)
alt_retrieval=fltarr(nltes,nttes)
time_retrieval=fltarr(nltes,nttes)
lat_retrieval=fltarr(nltes,nttes)
lon_retrieval=fltarr(nltes,nttes)
readu,88,cld_opt_depth,pres_retrieval,alt_retrieval,time_retrieval,lat_retrieval,lon_retrieval
readu,88,co_retrieval,co_initial,co_precision
readu,88,o3_retrieval,o3_initial,o3_precision
close,88
lons=lon_retrieval(0,*)
lats=lat_retrieval(0,*)
print,max(lats),min(lats)
!psym=-2
oplot,lons,lats
!psym=0
xyouts,lons(nttes/2),lats(nttes/2),'TES '+teslab

endfor
endif
endif
xmn=.1   ; lower-left
xmx=.9   ; lower-right
ymn=.15  ; the third element of set_viewport
ymx=.9  ; the fourth element of set_viewport
cbaryoff=.05; y distance between plot origin and colorbar origin
cbarydel=.01 ; thickness of colorbar
icmm1=253. ; icolmax-1, where icolmax is (number of colors) - 1
xtitle='(sec!u-1!n)'
color_bar_png,level,xmn,ymn,xmx,ymx,cbaryoff,cbarydel,icmm1,xtitle


if setplot eq 'Z' then begin
 image=tvrd(0,0,nxpng,nypng)
 image_byt=bytscl(image,min=0,max=255)
 index=where(image_byt gt 0B and image_byt lt 255B)
 tvlct,r,g,b,/get
pngdir='PNG_images/'
 write_png,pngdir+ifile+'.qdf.'+zlab(l)+'.anal.small.domain.png',image_byt,r,g,b
endif
;
; plot rdf WindSpeed
;
title=zlab(l)+' '+dlab(ifl)+' Lagrangian Wind Speed '+date
erase
set_viewport,.2,.8,.15,.9
mcolor=253.
map_set,0,-180,0,/continents,/us,limit=[30,120,45,135],$
title=title
daymap=reform(ptracer(nt+4,*,*,l),nx,ny)
level=60.*findgen(31)/30.
color=mcolor*findgen(31)/30.
contour,daymap,xgrd,ygrd,/overplot,level=level,/cell_fill,c_colors=color
map_set,0,-180,0,/continents,/us,limit=[30,120,45,135],$
/noeras
map_grid_ck,londel=5,latdel=1,/label
!p.thick=1
colors=mcolor+[0B,0B,0B,0B,0B,0B,0B]
;       DrawCounties, 'co2000p020.shp', Statenames=['CA', 'OR', 'WA', 'AZ', 'UT', 'ID', 'NV'], $
          Colors=colors
;
; draw vectors
;
maxmag=17.5
nh=1
!psym=0
vcolor=mcolor-.3*mcolor
vcolor=mcolor
xmax=250
xmin=90
ymax=90
ymin=50
xmax=250
xmin=225
ymax=45
ymin=25
xmax=260
xmin=235
ymax=50
ymin=30
xmax=255
xmin=195
ymax=60
ymin=15
xmax=135
xmin=120
ymax=45
ymin=30

!linetype=0
drawvectors_all,xmax,xmin,ymax,ymin,nc,nr,alon,alat,udata,vdata,maxmag,nh,vcolor
;Latitude: 40 03 00.10028(N)
;Longitude: 105 00 13.80781(W)
!psym=4
oplot,[-105.,-105.],[40.5,40.5]
!psym=0
;ktlx_range_ring
print,max(daymap),min(daymap)
if tesplot ne '.false.' then begin
close,2
openr,2,tesfiles
ntes=0l
readf,2,ntes
if ntes ne 0 then begin
tesfile=''
for ntimes=0,ntes-1 do begin
readf,2,tesfile
teslab=strmid(tesfile,35,9)
close,88
openr,88,tesdir+tesfile,/f77
nttes=0l
nltes=0l
readu,88,nltes,nttes
print,nltes,nttes
co_retrieval=fltarr(nltes,nttes)
co_initial=fltarr(nltes,nttes)
co_precision=fltarr(nltes,nttes)
o3_retrieval=fltarr(nltes,nttes)
o3_initial=fltarr(nltes,nttes)
o3_precision=fltarr(nltes,nttes)
cld_opt_depth=fltarr(nltes,nttes)
pres_retrieval=fltarr(nltes,nttes)
alt_retrieval=fltarr(nltes,nttes)
time_retrieval=fltarr(nltes,nttes)
lat_retrieval=fltarr(nltes,nttes)
lon_retrieval=fltarr(nltes,nttes)
readu,88,cld_opt_depth,pres_retrieval,alt_retrieval,time_retrieval,lat_retrieval,lon_retrieval
readu,88,co_retrieval,co_initial,co_precision
readu,88,o3_retrieval,o3_initial,o3_precision
close,88
lons=lon_retrieval(0,*)
lats=lat_retrieval(0,*)
print,max(lats),min(lats)
!psym=-2
oplot,lons,lats
!psym=0
xyouts,lons(nttes/2),lats(nttes/2),'TES '+teslab

endfor
endif
endif
xmn=.1   ; lower-left
xmx=.9   ; lower-right
ymn=.15  ; the third element of set_viewport
ymx=.9  ; the fourth element of set_viewport
cbaryoff=.05; y distance between plot origin and colorbar origin
cbarydel=.01 ; thickness of colorbar
icmm1=253. ; icolmax-1, where icolmax is (number of colors) - 1
xtitle='(m/s)'
color_bar_png,level,xmn,ymn,xmx,ymx,cbaryoff,cbarydel,icmm1,xtitle


if setplot eq 'Z' then begin
 image=tvrd(0,0,nxpng,nypng)
 image_byt=bytscl(image,min=0,max=255)
 index=where(image_byt gt 0B and image_byt lt 255B)
 tvlct,r,g,b,/get
pngdir='PNG_images/'
 write_png,pngdir+ifile+'.speed.'+zlab(l)+'.anal.small.domain.png',image_byt,r,g,b
endif
;
; plot rdf CO
;
title=zlab(l)+' '+dlab(ifl)+' Lagrangian Averaged CO '+date
erase
set_viewport,.2,.8,.15,.9
mcolor=253.
map_set,0,-180,0,/continents,/us,limit=[30,120,45,135],$ 
title=title
daymap=1.e9*reform(ptracer(ico,*,*,l),nx,ny)
level=300.*findgen(31)/30.
if l eq nlev-1 then level=300.*findgen(31)/30.
color=mcolor*findgen(31)/30.
contour,daymap,xgrd,ygrd,/overplot,level=level,/cell_fill,c_colors=color
map_set,0,-180,0,/continents,/us,limit=[30,120,45,135],$ 
/noeras
map_grid_ck,londel=5,latdel=1,/label
!p.thick=1
colors=mcolor+[0B,0B,0B,0B,0B,0B,0B]
;       DrawCounties, 'co2000p020.shp', Statenames=['CA', 'OR', 'WA', 'AZ', 'UT', 'ID', 'NV'], $
          Colors=colors
;
; draw vectors
;
maxmag=17.5
nh=1
!psym=0
vcolor=mcolor-.3*mcolor
vcolor=mcolor
xmax=250
xmin=90
ymax=90
ymin=50
xmax=250
xmin=225
ymax=45
ymin=25
xmax=260
xmin=235
ymax=50
ymin=30
xmax=255
xmin=195
ymax=60
ymin=15
xmax=135
xmin=120
ymax=45
ymin=30

!linetype=0
drawvectors_all,xmax,xmin,ymax,ymin,nc,nr,alon,alat,udata,vdata,maxmag,nh,vcolor
;Latitude: 40 03 00.10028(N)
;Longitude: 105 00 13.80781(W)
!psym=4
oplot,[-105.,-105.],[40.5,40.5]
!psym=0
;ktlx_range_ring
print,max(daymap),min(daymap)
if tesplot ne '.false.' then begin
close,2
openr,2,tesfiles
ntes=0l
readf,2,ntes
if ntes ne 0 then begin
tesfile=''
for ntimes=0,ntes-1 do begin
readf,2,tesfile
teslab=strmid(tesfile,35,9)
close,88
openr,88,tesdir+tesfile,/f77
nttes=0l
nltes=0l
readu,88,nltes,nttes
print,nltes,nttes
co_retrieval=fltarr(nltes,nttes)
co_initial=fltarr(nltes,nttes)
co_precision=fltarr(nltes,nttes)
o3_retrieval=fltarr(nltes,nttes)
o3_initial=fltarr(nltes,nttes)
o3_precision=fltarr(nltes,nttes)
cld_opt_depth=fltarr(nltes,nttes)
pres_retrieval=fltarr(nltes,nttes)
alt_retrieval=fltarr(nltes,nttes)
time_retrieval=fltarr(nltes,nttes)
lat_retrieval=fltarr(nltes,nttes)
lon_retrieval=fltarr(nltes,nttes)
readu,88,cld_opt_depth,pres_retrieval,alt_retrieval,time_retrieval,lat_retrieval,lon_retrieval
readu,88,co_retrieval,co_initial,co_precision
readu,88,o3_retrieval,o3_initial,o3_precision
close,88
lons=lon_retrieval(0,*)
lats=lat_retrieval(0,*)
print,max(lats),min(lats)
!psym=-2
oplot,lons,lats
!psym=0
xyouts,lons(nttes/2),lats(nttes/2),'TES '+teslab

endfor
endif
endif
xmn=.1   ; lower-left
xmx=.9   ; lower-right
ymn=.15  ; the third element of set_viewport
ymx=.9  ; the fourth element of set_viewport
cbaryoff=.05; y distance between plot origin and colorbar origin
cbarydel=.01 ; thickness of colorbar
icmm1=253. ; icolmax-1, where icolmax is (number of colors) - 1
xtitle='(ppbv)
color_bar_png,level,xmn,ymn,xmx,ymx,cbaryoff,cbarydel,icmm1,xtitle


if setplot eq 'Z' then begin
 image=tvrd(0,0,nxpng,nypng)
 image_byt=bytscl(image,min=0,max=255)
 index=where(image_byt gt 0B and image_byt lt 255B)
 tvlct,r,g,b,/get
pngdir='PNG_images/'
 write_png,pngdir+ifile+'.ico.'+zlab(l)+'.anal.small.domain.png',image_byt,r,g,b
endif
;
; plot rdf Sea Salt
;
title=zlab(l)+' '+dlab(ifl)+' Lagrangian Averaged Sea Salt '+date
erase
set_viewport,.2,.8,.15,.9
mcolor=253.
map_set,0,-180,0,/continents,/us,limit=[30,120,45,135],$
title=title
daymap=1.e9*reform(ptracer(issalt,*,*,l),nx,ny)
level=20.*findgen(31)/30.
color=mcolor*findgen(31)/30.
contour,daymap,xgrd,ygrd,/overplot,level=level,/cell_fill,c_colors=color
map_set,0,-180,0,/continents,/us,limit=[30,120,45,135],$
/noeras
map_grid_ck,londel=5,latdel=1,/label
!p.thick=1
colors=mcolor+[0B,0B,0B,0B,0B,0B,0B]
;       DrawCounties, 'co2000p020.shp', Statenames=['CA', 'OR', 'WA', 'AZ', 'UT', 'ID', 'NV'], $
          Colors=colors
;
; draw vectors
;
maxmag=17.5
nh=1
!psym=0
vcolor=mcolor-.3*mcolor
vcolor=mcolor
xmax=250
xmin=90
ymax=90
ymin=50
xmax=250
xmin=225
ymax=45
ymin=25
xmax=260
xmin=235
ymax=50
ymin=30
xmax=255
xmin=195
ymax=60
ymin=15
xmax=135
xmin=120
ymax=45
ymin=30

!linetype=0
drawvectors_all,xmax,xmin,ymax,ymin,nc,nr,alon,alat,udata,vdata,maxmag,nh,vcolor
;Latitude: 40 03 00.10028(N)
;Longitude: 105 00 13.80781(W)
!psym=4
oplot,[-105.,-105.],[40.5,40.5]
!psym=0

;ktlx_range_ring
print,max(daymap),min(daymap)
xmn=.1   ; lower-left
xmx=.9   ; lower-right
ymn=.15  ; the third element of set_viewport
ymx=.9  ; the fourth element of set_viewport
cbaryoff=.05; y distance between plot origin and colorbar origin
cbarydel=.01 ; thickness of colorbar
icmm1=253. ; icolmax-1, where icolmax is (number of colors) - 1
xtitle='(nano-grams/gram)
color_bar_png,level,xmn,ymn,xmx,ymx,cbaryoff,cbarydel,icmm1,xtitle


if setplot eq 'Z' then begin
 image=tvrd(0,0,nxpng,nypng)
 image_byt=bytscl(image,min=0,max=255)
 index=where(image_byt gt 0B and image_byt lt 255B)
 tvlct,r,g,b,/get
pngdir='PNG_images/'
 write_png,pngdir+ifile+'.issalt.'+zlab(l)+'.anal.small.domain.png',image_byt,r,g,b
endif
;
; plot rdf Ox P-L 
;
title=zlab(l)+' '+dlab(ifl)+' Lagrangian Averaged O3 P-L '+date
erase
set_viewport,.2,.8,.15,.9
mcolor=253.
map_set,0,-180,0,/continents,/us,limit=[30,120,45,135],$
title=title
daymap=1.e9*reform(ptracer(ioxprod,*,*,l),nx,ny)
level=-4+19.*findgen(31)/30.
color=mcolor*findgen(31)/30.
contour,daymap,xgrd,ygrd,/overplot,level=level,/cell_fill,c_colors=color
map_set,0,-180,0,/continents,/us,limit=[30,120,45,135],$
/noeras
map_grid_ck,londel=5,latdel=1,/label
!p.thick=1
colors=mcolor+[0B,0B,0B,0B,0B,0B,0B]
;       DrawCounties, 'co2000p020.shp', Statenames=['CA', 'OR', 'WA', 'AZ', 'UT', 'ID', 'NV'], $
          Colors=colors
;
; draw vectors
;
maxmag=17.5
nh=1
!psym=0
vcolor=mcolor-.3*mcolor
vcolor=mcolor
xmax=250
xmin=90
ymin=50
xmax=250
xmin=225
ymax=45
ymin=25
xmax=260
xmin=235
ymax=50
ymin=30
xmax=255
xmin=195
ymax=60
ymin=15
xmax=135
xmin=120
ymax=45
ymin=30

!linetype=0
drawvectors_all,xmax,xmin,ymax,ymin,nc,nr,alon,alat,udata,vdata,maxmag,nh,vcolor
;Latitude: 40 03 00.10028(N)
;Longitude: 105 00 13.80781(W)
!psym=4
oplot,[-105.,-105.],[40.5,40.5]
!psym=0
;ktlx_range_ring
print,max(daymap),min(daymap)
xmn=.1   ; lower-left
xmx=.9   ; lower-right
ymn=.15  ; the third element of set_viewport
ymx=.9  ; the fourth element of set_viewport
cbaryoff=.05; y distance between plot origin and colorbar origin
cbarydel=.01 ; thickness of colorbar
icmm1=253. ; icolmax-1, where icolmax is (number of colors) - 1
xtitle='(ppbv/day)
color_bar_png,level,xmn,ymn,xmx,ymx,cbaryoff,cbarydel,icmm1,xtitle


if setplot eq 'Z' then begin
 image=tvrd(0,0,nxpng,nypng)
 image_byt=bytscl(image,min=0,max=255)
 index=where(image_byt gt 0B and image_byt lt 255B)
 tvlct,r,g,b,/get
pngdir='PNG_images/'
 write_png,pngdir+ifile+'.ioxprod.'+zlab(l)+'.anal.small.domain.png',image_byt,r,g,b
endif
;
; plot rdf  BC+OC
;
title=zlab(l)+' '+dlab(ifl)+' Lagrangian Averaged BC+OC '+date
erase
set_viewport,.2,.8,.15,.9
mcolor=253.
map_set,0,-180,0,/continents,/us,limit=[30,120,45,135],$
title=title
daymap=1.e9*reform(ptracer(ibcoc,*,*,l),nx,ny)
level=20.*findgen(31)/30.
color=mcolor*findgen(31)/30.
contour,daymap,xgrd,ygrd,/overplot,level=level,/cell_fill,c_colors=color
map_set,0,-180,0,/continents,/us,limit=[30,120,45,135],$
/noeras
map_grid_ck,londel=5,latdel=1,/label
!p.thick=1
colors=mcolor+[0B,0B,0B,0B,0B,0B,0B]
;       DrawCounties, 'co2000p020.shp', Statenames=['CA', 'OR', 'WA', 'AZ', 'UT', 'ID', 'NV'], $
          Colors=colors
;
; draw vectors
;
maxmag=17.5
nh=1
!psym=0
vcolor=mcolor-.3*mcolor
vcolor=mcolor
xmax=250
xmin=90
ymin=50
xmax=250
xmin=225
ymax=45
ymin=25
xmax=260
xmin=235
ymax=50
ymin=30
xmax=255
xmin=195
ymax=60
ymin=15
xmax=135
xmin=120
ymax=45
ymin=30

!linetype=0
drawvectors_all,xmax,xmin,ymax,ymin,nc,nr,alon,alat,udata,vdata,maxmag,nh,vcolor
;Latitude: 40 03 00.10028(N)
;Longitude: 105 00 13.80781(W)
!psym=4
oplot,[-105.,-105.],[40.5,40.5]
!psym=0
;ktlx_range_ring
print,max(daymap),min(daymap)
xmn=.1   ; lower-left
xmx=.9   ; lower-right
ymn=.15  ; the third element of set_viewport
ymx=.9  ; the fourth element of set_viewport
cbaryoff=.05; y distance between plot origin and colorbar origin
cbarydel=.01 ; thickness of colorbar
icmm1=253. ; icolmax-1, where icolmax is (number of colors) - 1
xtitle='(ppbv)
color_bar_png,level,xmn,ymn,xmx,ymx,cbaryoff,cbarydel,icmm1,xtitle
if setplot eq 'Z' then begin
 image=tvrd(0,0,nxpng,nypng)
 image_byt=bytscl(image,min=0,max=255)
 index=where(image_byt gt 0B and image_byt lt 255B)
 tvlct,r,g,b,/get
pngdir='PNG_images/'
 write_png,pngdir+ifile+'.ibcoc.'+zlab(l)+'.anal.small.domain.png',image_byt,r,g,b
endif
;
; plot rdf  SO4
;
title=zlab(l)+' '+dlab(ifl)+' Lagrangian Averaged SO4 '+date
erase
set_viewport,.2,.8,.15,.9
mcolor=253.
map_set,0,-180,0,/continents,/us,limit=[30,120,45,135],$
title=title
daymap=1.e12*reform(ptracer(iso4,*,*,l),nx,ny)
level=200.*findgen(31)/30.
color=mcolor*findgen(31)/30.
contour,daymap,xgrd,ygrd,/overplot,level=level,/cell_fill,c_colors=color
map_set,0,-180,0,/continents,/us,limit=[30,120,45,135],$
/noeras
map_grid_ck,londel=5,latdel=1,/label
!p.thick=1
colors=mcolor+[0B,0B,0B,0B,0B,0B,0B]
;       DrawCounties, 'co2000p020.shp', Statenames=['CA', 'OR', 'WA', 'AZ', 'UT', 'ID', 'NV'], $
          Colors=colors
;
; draw vectors
;
maxmag=17.5
nh=1
!psym=0
vcolor=mcolor-.3*mcolor
vcolor=mcolor
xmax=250
xmin=90
ymin=50
xmax=250
xmin=225
ymax=45
ymin=25
xmax=260
xmin=235
ymax=50
ymin=30
xmax=255
xmin=195
ymax=60
ymin=15
xmax=135
xmin=120
ymax=45
ymin=30
!linetype=0
drawvectors_all,xmax,xmin,ymax,ymin,nc,nr,alon,alat,udata,vdata,maxmag,nh,vcolor
;Latitude: 40 03 00.10028(N)
;Longitude: 105 00 13.80781(W)
!psym=4
oplot,[-105.,-105.],[40.5,40.5]
!psym=0
;ktlx_range_ring
print,max(daymap),min(daymap)
xmn=.1   ; lower-left
xmx=.9   ; lower-right
ymn=.15  ; the third element of set_viewport
ymx=.9  ; the fourth element of set_viewport
cbaryoff=.05; y distance between plot origin and colorbar origin
cbarydel=.01 ; thickness of colorbar
icmm1=253. ; icolmax-1, where icolmax is (number of colors) - 1
xtitle='(pptv)
color_bar_png,level,xmn,ymn,xmx,ymx,cbaryoff,cbarydel,icmm1,xtitle
if setplot eq 'Z' then begin
 image=tvrd(0,0,nxpng,nypng)
 image_byt=bytscl(image,min=0,max=255)
 index=where(image_byt gt 0B and image_byt lt 255B)
 tvlct,r,g,b,/get
pngdir='PNG_images/'
 write_png,pngdir+ifile+'.iso4.'+zlab(l)+'.anal.small.domain.png',image_byt,r,g,b
endif
;
; plot rdf  Dust
;
title=zlab(l)+' '+dlab(ifl)+' Lagrangian Averaged Dust '+date
erase
set_viewport,.2,.8,.15,.9
mcolor=253.
map_set,0,-180,0,/continents,/us,limit=[30,120,45,135],$
title=title
daymap=1.e9*reform(ptracer(idust,*,*,l),nx,ny)
level=10.*findgen(31)/30.
color=mcolor*findgen(31)/30.
contour,daymap,xgrd,ygrd,/overplot,level=level,/cell_fill,c_colors=color
map_set,0,-180,0,/continents,/us,limit=[30,120,45,135],$
/noeras
map_grid_ck,londel=5,latdel=1,/label
!p.thick=1
colors=mcolor+[0B,0B,0B,0B,0B,0B,0B]
;       DrawCounties, 'co2000p020.shp', Statenames=['CA', 'OR', 'WA', 'AZ', 'UT', 'ID', 'NV'], $
          Colors=colors
;
; draw vectors
;
maxmag=17.5
nh=1
!psym=0
vcolor=mcolor-.3*mcolor
vcolor=mcolor
xmax=250
xmin=90
ymin=50
xmax=250
xmin=225
ymax=45
ymin=25
xmax=260
xmin=235
ymax=50
ymin=30
xmax=255
xmin=195
ymax=60
ymin=15
xmax=135
xmin=120
ymax=45
ymin=30
!linetype=0
drawvectors_all,xmax,xmin,ymax,ymin,nc,nr,alon,alat,udata,vdata,maxmag,nh,vcolor
;Latitude: 40 03 00.10028(N)
;Longitude: 105 00 13.80781(W)
!psym=4
oplot,[-105.,-105.],[40.5,40.5]
!psym=0
;ktlx_range_ring
print,max(daymap),min(daymap)
xmn=.1   ; lower-left
xmx=.9   ; lower-right
ymn=.15  ; the third element of set_viewport
ymx=.9  ; the fourth element of set_viewport
cbaryoff=.05; y distance between plot origin and colorbar origin
cbarydel=.01 ; thickness of colorbar
icmm1=253. ; icolmax-1, where icolmax is (number of colors) - 1
xtitle='(nano-grams/gram)
color_bar_png,level,xmn,ymn,xmx,ymx,cbaryoff,cbarydel,icmm1,xtitle
if setplot eq 'Z' then begin
 image=tvrd(0,0,nxpng,nypng)
 image_byt=bytscl(image,min=0,max=255)
 index=where(image_byt gt 0B and image_byt lt 255B)
 tvlct,r,g,b,/get
pngdir='PNG_images/'
 write_png,pngdir+ifile+'.idust.'+zlab(l)+'.anal.small.domain.png',image_byt,r,g,b
endif
;
;
; plot rdf O3 tracer
;
title=zlab(l)+' '+dlab(ifl)+' Lagrangian Averaged Ozone '+date
erase
set_viewport,.2,.8,.15,.9
mcolor=253.
map_set,0,-180,0,/continents,/us,limit=[30,120,45,135],$ 
title=title
daymap=1.e9*reform(ptracer(iox,*,*,l),nx,ny)
level=90.*findgen(31)/30.
color=mcolor*findgen(31)/30.
contour,daymap,xgrd,ygrd,/overplot,level=level,/cell_fill,c_colors=color
map_set,0,-180,0,/continents,/us,limit=[30,120,45,135],$ 
/noeras
map_grid_ck,londel=5,latdel=1,/label
!p.thick=1
colors=mcolor+[0B,0B,0B,0B,0B,0B,0B]
;       DrawCounties, 'co2000p020.shp', Statenames=['CA', 'OR', 'WA', 'AZ', 'UT', 'ID', 'NV'], $
          Colors=colors
;
; draw vectors
;
maxmag=17.5
nh=1
!psym=0
vcolor=mcolor-.3*mcolor
vcolor=mcolor
xmax=250
xmin=90
ymax=90
ymin=50
xmax=250
xmin=225
ymax=45
ymin=25
xmax=260
xmin=235
ymax=50
ymin=30
xmax=255
xmin=195
ymax=60
ymin=15
xmax=135
xmin=120
ymax=45
ymin=30

!linetype=0
drawvectors_all,xmax,xmin,ymax,ymin,nc,nr,alon,alat,udata,vdata,maxmag,nh,vcolor
;Latitude: 40 03 00.10028(N)
;Longitude: 105 00 13.80781(W)
!psym=4
oplot,[-105.,-105.],[40.5,40.5]
!psym=0
;ktlx_range_ring

print,max(daymap),min(daymap)
if tesplot ne '.false.' then begin
close,2
openr,2,tesfiles
ntes=0l
readf,2,ntes
if ntes ne 0 then begin
tesfile=''
for ntimes=0,ntes-1 do begin
readf,2,tesfile
teslab=strmid(tesfile,35,9)
close,88
openr,88,tesdir+tesfile,/f77
nttes=0l
nltes=0l
readu,88,nltes,nttes
print,nltes,nttes
co_retrieval=fltarr(nltes,nttes)
co_initial=fltarr(nltes,nttes)
co_precision=fltarr(nltes,nttes)
o3_retrieval=fltarr(nltes,nttes)
o3_initial=fltarr(nltes,nttes)
o3_precision=fltarr(nltes,nttes)
cld_opt_depth=fltarr(nltes,nttes)
pres_retrieval=fltarr(nltes,nttes)
alt_retrieval=fltarr(nltes,nttes)
time_retrieval=fltarr(nltes,nttes)
lat_retrieval=fltarr(nltes,nttes)
lon_retrieval=fltarr(nltes,nttes)
readu,88,cld_opt_depth,pres_retrieval,alt_retrieval,time_retrieval,lat_retrieval,lon_retrieval
readu,88,co_retrieval,co_initial,co_precision
readu,88,o3_retrieval,o3_initial,o3_precision
close,88
lons=lon_retrieval(0,*)
lats=lat_retrieval(0,*)
print,max(lats),min(lats)
!psym=-2
oplot,lons,lats
!psym=0
xyouts,lons(nttes/2),lats(nttes/2),'TES '+teslab

endfor
endif
endif
xmn=.1   ; lower-left
xmx=.9   ; lower-right
ymn=.15  ; the third element of set_viewport
ymx=.9  ; the fourth element of set_viewport
cbaryoff=.05; y distance between plot origin and colorbar origin
cbarydel=.01 ; thickness of colorbar
icmm1=253. ; icolmax-1, where icolmax is (number of colors) - 1
xtitle='(ppbv)'
color_bar_png,level,xmn,ymn,xmx,ymx,cbaryoff,cbarydel,icmm1,xtitle


if setplot eq 'Z' then begin
 image=tvrd(0,0,nxpng,nypng)
 image_byt=bytscl(image,min=0,max=255)
 index=where(image_byt gt 0B and image_byt lt 255B)
 tvlct,r,g,b,/get
pngdir='PNG_images/'
 write_png,pngdir+ifile+'.iox.'+zlab(l)+'.anal.small.domain.png',image_byt,r,g,b

endif

;
; plot rdf pbltropics
;
title=zlab(l)+' '+dlab(ifl)+' Lagrangian averaged Tropical PBL Exposure (%)'+date
erase
set_viewport,.2,.8,.15,.9
mcolor=253.
map_set,0,-180,0,/continents,/us,limit=[30,120,45,135],$ 
title=title
daymap=100.*reform(ptracer(nt+1,*,*,l),nx,ny)
level=100*findgen(31)/30.
color=mcolor*findgen(31)/30.
contour,daymap,xgrd,ygrd,/overplot,level=level,/cell_fill,c_colors=color
map_set,0,-180,0,/continents,/us,limit=[30,120,45,135],$ 
/noeras
map_grid_ck,londel=5,latdel=1,/label
!p.thick=1
colors=mcolor+[0B,0B,0B,0B,0B,0B,0B]
;       DrawCounties, 'co2000p020.shp', Statenames=['CA', 'OR', 'WA', 'AZ', 'UT', 'ID', 'NV'], $
          Colors=colors
;
; draw vectors
;
maxmag=17.5
nh=1
!psym=0
vcolor=mcolor-.3*mcolor
vcolor=mcolor
xmax=250
xmin=90
ymax=90
ymin=50
xmax=250
xmin=225
ymax=45
ymin=25
xmax=260
xmin=235
ymax=50
ymin=30
xmax=255
xmin=195
ymax=60
ymin=15
xmax=135
xmin=120
ymax=45
ymin=30

!linetype=0
drawvectors_all,xmax,xmin,ymax,ymin,nc,nr,alon,alat,udata,vdata,maxmag,nh,vcolor
;Latitude: 40 03 00.10028(N)
;Longitude: 105 00 13.80781(W)
!psym=4
oplot,[-105.,-105.],[40.5,40.5]
!psym=0
;ktlx_range_ring

print,max(daymap),min(daymap)
if tesplot ne '.false.' then begin
close,2
openr,2,tesfiles
ntes=0l
readf,2,ntes
if ntes ne 0 then begin
tesfile=''
for ntimes=0,ntes-1 do begin
readf,2,tesfile
teslab=strmid(tesfile,35,9)
close,88
openr,88,tesdir+tesfile,/f77
nttes=0l
nltes=0l
readu,88,nltes,nttes
print,nltes,nttes
co_retrieval=fltarr(nltes,nttes)
co_initial=fltarr(nltes,nttes)
co_precision=fltarr(nltes,nttes)
o3_retrieval=fltarr(nltes,nttes)
o3_initial=fltarr(nltes,nttes)
o3_precision=fltarr(nltes,nttes)
cld_opt_depth=fltarr(nltes,nttes)
pres_retrieval=fltarr(nltes,nttes)
alt_retrieval=fltarr(nltes,nttes)
time_retrieval=fltarr(nltes,nttes)
lat_retrieval=fltarr(nltes,nttes)
lon_retrieval=fltarr(nltes,nttes)
readu,88,cld_opt_depth,pres_retrieval,alt_retrieval,time_retrieval,lat_retrieval,lon_retrieval
readu,88,co_retrieval,co_initial,co_precision
readu,88,o3_retrieval,o3_initial,o3_precision
close,88
lons=lon_retrieval(0,*)
lats=lat_retrieval(0,*)
print,max(lats),min(lats)
!psym=-2
oplot,lons,lats
!psym=0
xyouts,lons(nttes/2),lats(nttes/2),'TES '+teslab

endfor
endif
endif
xmn=.1   ; lower-left
xmx=.9   ; lower-right
ymn=.15  ; the third element of set_viewport
ymx=.9  ; the fourth element of set_viewport
cbaryoff=.05; y distance between plot origin and colorbar origin
cbarydel=.01 ; thickness of colorbar
icmm1=253. ; icolmax-1, where icolmax is (number of colors) - 1
xtitle='(%)'
color_bar_png,level,xmn,ymn,xmx,ymx,cbaryoff,cbarydel,icmm1,xtitle


if setplot eq 'Z' then begin
 image=tvrd(0,0,nxpng,nypng)
 image_byt=bytscl(image,min=0,max=255)
 index=where(image_byt gt 0B and image_byt lt 255B)
 tvlct,r,g,b,/get
pngdir='PNG_images/'
 write_png,pngdir+ifile+'.ipbl.conus.'+zlab(l)+'.anal.small.domain.png',image_byt,r,g,b
endif
;
; plot rdf pbleasia
;
title=zlab(l)+' '+dlab(ifl)+' Lagrangian averaged East Asian PBL Exposure (%)'+date
erase
set_viewport,.2,.8,.15,.9
mcolor=253.
map_set,0,-180,0,/continents,/us,limit=[30,120,45,135],$
title=title
daymap=100.*reform(ptracer(nt+2,*,*,l),nx,ny)
level=20*findgen(31)/30.
color=mcolor*findgen(31)/30.
contour,daymap,xgrd,ygrd,/overplot,level=level,/cell_fill,c_colors=color
map_set,0,-180,0,/continents,/us,limit=[30,120,45,135],$
/noeras
map_grid_ck,londel=5,latdel=1,/label
!p.thick=1
colors=mcolor+[0B,0B,0B,0B,0B,0B,0B]
;       DrawCounties, 'co2000p020.shp', Statenames=['CA', 'OR', 'WA', 'AZ', 'UT', 'ID', 'NV'], $
          Colors=colors
;
; draw vectors
;
maxmag=17.5
nh=1
!psym=0
vcolor=mcolor-.3*mcolor
vcolor=mcolor
xmax=250
xmin=90
ymin=50
xmax=250
xmin=225
ymax=45
ymin=25
xmax=260
xmin=235
ymax=50
ymin=30
xmax=255
xmin=195
ymax=60
ymin=15
xmax=135
xmin=120
ymax=45
ymin=30
!linetype=0
drawvectors_all,xmax,xmin,ymax,ymin,nc,nr,alon,alat,udata,vdata,maxmag,nh,vcolor
;Latitude: 40 03 00.10028(N)
;Longitude: 105 00 13.80781(W)
!psym=4
oplot,[-105.,-105.],[40.5,40.5]
!psym=0
;ktlx_range_ring
print,max(daymap),min(daymap)
xmn=.1   ; lower-left
xmx=.9   ; lower-right
ymn=.15  ; the third element of set_viewport
ymx=.9  ; the fourth element of set_viewport
cbaryoff=.05; y distance between plot origin and colorbar origin
cbarydel=.01 ; thickness of colorbar
icmm1=253. ; icolmax-1, where icolmax is (number of colors) - 1
xtitle='(%)'
color_bar_png,level,xmn,ymn,xmx,ymx,cbaryoff,cbarydel,icmm1,xtitle
if setplot eq 'Z' then begin
 image=tvrd(0,0,nxpng,nypng)
 image_byt=bytscl(image,min=0,max=255)
 index=where(image_byt gt 0B and image_byt lt 255B)
 tvlct,r,g,b,/get
pngdir='PNG_images/'
 write_png,pngdir+ifile+'.ipbl.easia.'+zlab(l)+'.anal.small.domain.png',image_byt,r,g,b
endif
;
; plot rdf strat
;
title=zlab(l)+' '+dlab(ifl)+' Lagrangian averaged Stratospheric Exposure (%)'+date
erase
set_viewport,.2,.8,.15,.9
mcolor=253.
map_set,0,-180,0,/continents,/us,limit=[30,120,45,135],$
title=title
daymap=100.*reform(ptracer(nt,*,*,l),nx,ny)
level=50*findgen(31)/30.
color=mcolor*findgen(31)/30.
contour,daymap,xgrd,ygrd,/overplot,level=level,/cell_fill,c_colors=color
map_set,0,-180,0,/continents,/us,limit=[30,120,45,135],$
/noeras
map_grid_ck,londel=5,latdel=1,/label
!p.thick=1
colors=mcolor+[0B,0B,0B,0B,0B,0B,0B]
;       DrawCounties, 'co2000p020.shp', Statenames=['CA', 'OR', 'WA', 'AZ', 'UT', 'ID', 'NV'], $
          Colors=colors
;
; draw vectors
;
maxmag=17.5
nh=1
!psym=0
vcolor=mcolor-.3*mcolor
vcolor=mcolor
xmax=250
xmin=90
ymax=90
ymin=50
xmax=250
xmin=225
ymax=45
ymin=25
xmax=260
xmin=235
ymax=50
ymin=30
xmax=255
xmin=195
ymax=60
ymin=15
xmax=135
xmin=120
ymax=45
ymin=30

!linetype=0
drawvectors_all,xmax,xmin,ymax,ymin,nc,nr,alon,alat,udata,vdata,maxmag,nh,vcolor
;Latitude: 40 03 00.10028(N)
;Longitude: 105 00 13.80781(W)
!psym=4
oplot,[-105.,-105.],[40.5,40.5]
!psym=0
;ktlx_range_ring

print,max(daymap),min(daymap)
if tesplot ne '.false.' then begin
close,2
openr,2,tesfiles
ntes=0l
readf,2,ntes
if ntes ne 0 then begin
tesfile=''
for ntimes=0,ntes-1 do begin
readf,2,tesfile
teslab=strmid(tesfile,35,9)
close,88
openr,88,tesdir+tesfile,/f77
nttes=0l
nltes=0l
readu,88,nltes,nttes
print,nltes,nttes
co_retrieval=fltarr(nltes,nttes)
co_initial=fltarr(nltes,nttes)
co_precision=fltarr(nltes,nttes)
o3_retrieval=fltarr(nltes,nttes)
o3_initial=fltarr(nltes,nttes)
o3_precision=fltarr(nltes,nttes)
cld_opt_depth=fltarr(nltes,nttes)
pres_retrieval=fltarr(nltes,nttes)
alt_retrieval=fltarr(nltes,nttes)
time_retrieval=fltarr(nltes,nttes)
lat_retrieval=fltarr(nltes,nttes)
lon_retrieval=fltarr(nltes,nttes)
readu,88,cld_opt_depth,pres_retrieval,alt_retrieval,time_retrieval,lat_retrieval,lon_retrieval
readu,88,co_retrieval,co_initial,co_precision
readu,88,o3_retrieval,o3_initial,o3_precision
close,88
lons=lon_retrieval(0,*)
lats=lat_retrieval(0,*)
print,max(lats),min(lats)
!psym=-2
oplot,lons,lats
!psym=0
xyouts,lons(nttes/2),lats(nttes/2),'TES '+teslab

endfor
endif
endif
xmn=.1   ; lower-left
xmx=.9   ; lower-right
ymn=.15  ; the third element of set_viewport
ymx=.9  ; the fourth element of set_viewport
cbaryoff=.05; y distance between plot origin and colorbar origin
cbarydel=.01 ; thickness of colorbar
icmm1=253. ; icolmax-1, where icolmax is (number of colors) - 1
xtitle='(%)'
color_bar_png,level,xmn,ymn,xmx,ymx,cbaryoff,cbarydel,icmm1,xtitle


if setplot eq 'Z' then begin
 image=tvrd(0,0,nxpng,nypng)
 image_byt=bytscl(image,min=0,max=255)
 index=where(image_byt gt 0B and image_byt lt 255B)
 tvlct,r,g,b,/get
pngdir='PNG_images/'
 write_png,pngdir+ifile+'.istrat.'+zlab(l)+'.anal.small.domain.png',image_byt,r,g,b
endif

endfor
jumpout:

endfor    ; end of loop over trajectory runs 

close,11
end

